function [xn,fn]=new(x,f,xMin,xMax,func,LB,out2inOption,cheap,pairs)
% Build the new point and evaluate it
global noWayCount outsideCount
global FE
global fMax

%{
 At the very beginning the intersection is necessarily
 either "noWay" or "outside".
We can avoid to check it
type:  0 = outside

       -1 = cheap option, subset to prepare barycenter
        1 = cheap option, barycenter
       2 = inside, normal
%}
[nCorners,~]=size(x);
if FE<=nCorners
  xn=out2in(f,x,LB,0,xMin,xMax);
  fn=fit(xn,func,0);
  outsideCount(1)=1;
  return
end
%}
% -------------------
D=numel(xMin);
[nPairs,~]=size(pairs); 

switch cheap
  case 0 % Normal method
    xn=normal(f,x,LB,out2inOption,xMin,xMax);
    type=2;
    
  case 1
    %{
    We use only pairs of points.
   Each pair defines a line that intersects (or not) the lower bound
    The set of intersections define a sub-population.
    The new position is the barycenter of this set.
    In case there are not enough intersections, the new point is defined
    as if "cheap" were false.
    %}
    nn=0;
    for np=1:nPairs
      n1=pairs(np,1); n2=pairs(np,2);
      xx(1,:)=x(n1,:);
      xx(2,:)=x(n2,:);
      ff(1)=f(n1);
      ff(2)=f(n2);
      if abs(ff(2)-ff(1))>0 % There is an intersectin
        % Check if inside
        lambda=(LB-ff(1))/(ff(2)-ff(1));
         xTemp=xx(1,:)+lambda*(xx(2,:)-xx(1,:));
 
        outside=outCheck(xTemp,xMin,xMax);
      
        if outside
          %{
          nn=nn+1;
          if ff(1)<ff(2) 
            xk(nn,:)=xx(1,:);
          else
            xk(nn,:)=xx(2,:);
          end
          %}
        else % Intersection is inside    
          nn=nn+1;
          xk(nn,:)=xTemp;
        end 
    end
    end
    
    if nn==nPairs % If enough positions
      for nk=1:nn
        fk(nk)=fit(xk(nk,:),func,-1);
      end
      xn=barycenter(fk,xk,LB);
      type=1;
    else % 
      %fprintf('\n new 70, nn %o',nn)
      xn=normal(f,x,LB,out2inOption,xMin,xMax);
      type=2;
    end
    
  case 2
% TO DO    
end % switch cheap

fn=fit(xn,func,type);
end


