function xn=normal(f,x,LB,out2inOption,xMin,xMax)
% (hyper)planes (or lines if D=1)
% Each plane needs D+1 points to be defined
% and we will need D linear equations to compute a new D-position
global FE
D=numel(xMin);
for n=1:D
  P=[];
  F=[];
  for d=1:D+1
    rank=n+d-1;
    P=[P;x(rank,:)];
    F=[F;f(rank)];
  end
  Plane(n,1:D+1)=plane(P,F);
end

P=[]; % Concatenation
for n=1:D
  P=[P;Plane(n,:)];
end

% Intersection with the lower bound plane
[xn,noWay]=intersect(P,LB);

if  noWay  % Intersection at infinity
  noWayCount(FE)=1; % For information
  outside=true;
else % Intersection, but maybe outside the search space
  outside=outCheck(xn,xMin,xMax);
  if outside outsideCount(FE)=-1; end % For information
end  % if noWay

if outside
  xn=out2in(f,x,LB,out2inOption,xMin,xMax);
end

end