function xn=out2in(f,x,LB,out2inOption,xMin,xMax)
% What to do when the intersection is outside the search space

global x0
global toCorner
global exploit FE
global magicList randRank

[nPoints,D]=size(x);
switch out2inOption
  case -2 % Random position "between" the 2^D current ones
    exploit(FE)=1;
    for d=1:D
      for n=1:nPoints
      r(n)=magicList(randRank);
      randRank=randRank+1;
      if randRank>numel(magicList) randRank=1; end
      end
      xn(d)=0;
      for n=1:nPoints
        xn(d)=xn(d)+r(n).*x(n,d);
      end
      xn(d)=xn(d)/sum(r);
    end
  case -1 % Random, whole space
    xn=xMin+rand(1,D).*(xMax-xMin);
    
  case 1
    % Select a corner, cyclically
     toCorner=toCorner+1;
    corner=1+mod(toCorner,nPoints);
   % Nearest x point 
    Ind=dsearchn(x,x0(corner,:));
    xNearest=x(Ind,:);
    
   % Towards the corner
   xn=xNearest+0.5*(x0(corner,:)-xNearest); %0.5?
        
  otherwise % Normal method. A position "between" the 2^D current ones
            % closer to the best ones
            % This can be seen as a kind of "exploitation"
     exploit(FE)=1;
     xn=barycenter(f,x,LB);  
end
end